/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
)

// ServicesTikTokStaticApiService ServicesTikTokStaticApi service
type ServicesTikTokStaticApiService service

type ApiAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest struct {
	ctx                                                       context.Context
	ApiService                                                *ServicesTikTokStaticApiService
	appAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest
}

//
func (r ApiAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest(appAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) ApiAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest {
	r.appAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest = &appAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest
	return r
}

func (r ApiAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) Execute() (*TikTokStaticUserAuth, *http.Response, error) {
	return r.ApiService.AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewExecute(r)
}

/*
AppAuthorizerTikTokStaticTikTokStaticAuthorizerNew Authorize a service

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest
*/
func (a *ServicesTikTokStaticApiService) AppAuthorizerTikTokStaticTikTokStaticAuthorizerNew(ctx context.Context) ApiAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest {
	return ApiAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return TikTokStaticUserAuth
func (a *ServicesTikTokStaticApiService) AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewExecute(r ApiAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) (*TikTokStaticUserAuth, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *TikTokStaticUserAuth
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ServicesTikTokStaticApiService.AppAuthorizerTikTokStaticTikTokStaticAuthorizerNew")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/services/tik_tok_static"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.appAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest == nil {
		return localVarReturnValue, nil, reportError("appAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
